TMP     EQU 0E7FFH
INADR   EQU TMP-2

aError: DB "o{ibka SD",0
PREVDIR: DB "..",0

;----------------------------------------------------------------------------
Error:     
     ;   " SD "
     LXI  H, aError
     CALL PRINT
     ;   
     POP  PSW  ; xsd    ,  ,      'C',      POP  ???
#ifdef MX2
     CALL 0F815h  ;   16- 
#else
     CALL 0C815h  ;   16- 
#endif
    LXI H,NEWLINE
    CALL PRINT
     ; 
;     JMP  $
   RET

;----------------------------------------------------------------------------
BiosEntry:
     PUSH H             ; 1
     LXI  H, JmpTbl     ; 2
     ADD  L             ; 1
     MOV  L, A          ; 1
     MOV  L, M          ; 1
     XTHL               ; 1
     RET                ; 1

;----------------------------------------------------------------------------
;  D600.   JmpTbl    
;  ORG 0D600H
JmpTbl:
     .db CmdExec1           ; 0 HL- , DE-   / A- 
     .db CmdFind1           ; 1 HL- , DE-   , BC- / HL- , A- 
     .db CmdOpenDelete1     ; 2 D-, HL-  / A- 
     .db CmdSeekGetSize1    ; 3 B-, DE:HL- / A- , DE:HL-
     .db CmdRead1           ; 4 HL-, DE- / HL- , A- 
     .db CmdWrite1          ; 5 HL-, DE- / A- 
     .db CmdMove1           ; 6 HL-, DE- / A- 
;----------------------------------------------------------------------------
;  ,    ,       2 
CmdExec1:
 JMP CmdExec
CmdFind1:
 JMP CmdFind
CmdOpenDelete1:
 JMP CmdOpenDelete
CmdSeekGetSize1:
 JMP CmdSeekGetSize
CmdRead1:
 JMP CmdRead
CmdWrite1:
 JMP CmdWrite
CmdMove1:
 JMP CmdMove

; HL- , DE-  / A- 

CmdExec:
     ;  H    
     ;        
  LXI D,CWD+1
Ce1:
  LDAX D
  CPI 00H
  JZ Ce2
  INX H
  INX D
  JMP Ce1
Ce2:
  XCHG   
;        
  LDAX D
  CPI 2FH
  JNZ Ce3
  INX D
Ce3:
  LXI H,LINEBUF
  CALL STRCPY
  LXI D,LINEBUF
  CALL F_OPEN
  LXI H,NOTFND
  JC Error
  LXI B,4
  LXI H,LINEBUF
  CALL F_READ
  LXI H,LINEBUF
  MOV A,M
  CPI 0E6H
  JNZ RUNF2
  LXI B,1
  LXI H,LINEBUF+4
  CALL F_READ
  LXI H,LINEBUF+1
  JMP RUNF2
  ;     ,       ?
;     POP H ;   
     ;   (  
;     LXI  SP, 07FFFh
;     PUSH H ;      
     ;  
;     MVI  C, 1Fh
;     CALL 0C809h
     ;   
;     MVI  A, 1    ;  
;     LXI  B, BiosEntry  ;   SD BIOS
;     LXI  D, SELF_NAME  ;  
;     LXI  H, CMD_LINE   ;  
     ;   
;     RET
;----------------------------------------------------------------------------
; HL-, DE-   , BC- / HL- , A- 

CmdFind:
;----------------------------
;     HL     xsd  CWD
; (HL)==(CWD)    Fnd1 
; (HL)>(CWD)       (HL)-(CWD)
; (HL)<(CWD)     '..'
;      +/-     
;1(Fnd0)   0 HL,   0,  goto 2,    0 CWD,   0,  goto 2, 
;     - JMP Fnd1
;2(Fnd4)    HL CWD,  0,   HL  CWD  goto 1,  goto 3
;3    ,  HL<CWD     '..',     
;
  PUSH B ;     
  LXI D,CWD+1
Fnd0:
  MVI A, 0 ;   0  
  CMP M ;  HL  (HL)
  JZ Fnd2 ; , HL==0
Fnd4:
  LDAX D 
  CMP M
  JNZ Fnd3
  INX H
  INX D
  JMP Fnd0 ;    , 
Fnd3:
  JC Fnd5; H     ,     '/',   
  LXI H,PREVDIR ;    

Fnd5:
  XCHG ;  ,   ,  H  D
  LDAX D
  CPI 02FH
  JNZ Fnd6
  INX D ;  
Fnd6:
  PUSH D
  CALL FS_CHDIR ;  D 
  POP D
  JMP Fnd1

Fnd2:
;  PUSH H
  LXI H,CWD+1
  MVI A, 0 ;   0  
  CMP M ;  HL  (CWD)
;  POP H
  JNZ Fnd6 ; , HL!=0,  

;----------------------------

Fnd1:
  LXI D,ALLFILS ;  D '*'    
  ;     
  POP H
  SHLD INADR
     ; 
  LXI H,TMP
  MVI  A, 0
  MOV M,A ;    

  CALL FS_FNDF ;  D   
  JC C_DIRNO
FC_DIR1: ;           
  PUSH H
  LXI B,11
  DAD B
  MOV A,M
  POP H
  ANI 8
  JNZ FC_DIR2
  ;    /...
  PUSH H ; H  D  , ...
  PUSH D
  XCHG
  LDAX D
  CPI 02EH
  JNZ FNOT_DIR
  XCHG
  POP D
  POP H
  JMP FC_DIR2
FNOT_DIR:
  LHLD INADR;  HL      ,   20 
  MVI B,12 ;  D    FAT   ,   32 
 ;  ,   
FLC_LOOP: 
  LDAX D
  INX D
  MOV M,A
  INX H
  DCR B
  JNZ FLC_LOOP

  MVI B,16 ;  6    10  ,  ,  ,...
  INX D
  DCR B
  JNZ $-2
  
  MVI B,4 ;    , ...
FLC_LOOP1: 
  LDAX D
  INX D
  MOV M,A
  INX H
  DCR B
  JNZ FLC_LOOP1

  MVI B,10 ;          ,   ...
  DCX D
  DCR B
  JNZ $-2

  MVI B,4 ;        
FLC_LOOP2: 
  LDAX D
  INX D
  MOV M,A
  INX H
  DCR B
  JNZ FLC_LOOP2

  SHLD INADR ; .    
  XCHG
  POP D
  POP H

  PUSH H
  LXI H,TMP ;  1  
  MOV A,M
  INR A
  MOV M,A
  POP H

FC_DIR2: CALL FS_FNDN
  JNC FC_DIR1
 ;  
  LXI H,TMP
  MOV  L,M
     ;  
     MVI  A, 0
  MOV H,A
  RET
FC_DIRNO:
     ;  
     MVI  A, 1

    RET
;----------------------------------------------------------------------------
; D-, HL-  / A- 

CmdOpenDelete: ;D- -  ,   
;    CmdExec,      ...
     ;  H    
     ;        
  LXI D,CWD+1
CODe1:
  LDAX D
  CPI 00H
  JZ Ce2
  INX H
  INX D
  JMP CODe1
CODe2:
  XCHG   
;        
  LDAX D
  CPI 2FH
  JNZ CODe3
  INX D
CODe3:
  LXI H,LINEBUF
  CALL STRCPY
  LXI D,LINEBUF
  CALL F_OPEN
  LXI H,NOTFND
  JC Error

     ;  
     MVI  A, 0

    RET     
;----------------------------------------------------------------------------
; B-, DE:HL- / A- , DE:HL-

CmdSeekGetSize: ;  ,   ,   
     ;  
     MVI  A, 0

    RET     
;----------------------------------------------------------------------------
; HL-, DE- / HL- , A- 

CmdRead:
;    CmdExec...

  LXI B,4
  LXI H,LINEBUF
  CALL F_READ
  LXI H,LINEBUF
  MOV A,M
  CPI 0E6H
  JNZ CmR1
  LXI B,1
  LXI H,LINEBUF+4
  CALL F_READ
  LXI H,LINEBUF+1
CmR1:

     ;  
     MVI  A, 0

    RET     
;----------------------------------------------------------------------------
; HL-, DE- / A- 

CmdWrite:
;     LXI  H, 0
     ;  
     MVI  A, 0

    RET     
;----------------------------------------------------------------------------
; HL-, DE- / A- 

CmdMove:     
;     LXI  H, 0
     ;  
     MVI  A, 0

    RET     
;----------------------------------------------------------------------------
